<template>
  <a-card :bordered='false' v-show='visible' class='card' :title='modalTitle'>
    <a-row :gutter='48' slot='extra'>
      <a-col :md='48' :sm='48'>
              <span class='table-page-search-submitButtons' style='float: right'>
                <a-button :loading='confirmLoading' type='primary' @click='save()'>保存</a-button>
                <a-button style='margin-left: 8px' type='default' @click='handleCancel()'>返回</a-button>
              </span>
      </a-col>
    </a-row>
    <a-form :form='form'>

      <a-form-item v-show='false'>
        <a-input v-decorator="['id']" type='hidden' />
        <a-input v-decorator="['spareStoreId']" type='hidden' />
      </a-form-item>

      <row-list :col='2'>
        <row-item>
          <a-form-item
            label='名称'
            :labelCol='BaseTool.Constant.labelCol'
            :wrapperCol='BaseTool.Constant.wrapperCol'
          >
            <a-input
              v-decorator="['name', {rules: [{required: true, message: '名称不能为空'}]}]" />
          </a-form-item>
        </row-item>
        <row-item>
          <a-form-item
            label='入库仓库'
            :labelCol='BaseTool.Constant.labelCol'
            :wrapperCol='BaseTool.Constant.wrapperCol'
          >
            <a-input
              style='width: 70%'
              disabled
              v-decorator="['spareStoreName', {rules: [{required: true, message: '仓库不能为空'}]}]" />
            <a-button style='width: 30%' type='primary' @click='spareStoreHandleSelect'>选择</a-button>
          </a-form-item>
        </row-item>
      </row-list>
    </a-form>
    <store-select-modal ref='storeSelectModal' @selected='spareStoreHandleSelectd' />
  </a-card>
</template>

<script>
import pick from 'lodash.pick'
import { addPurchaseStoreForm, updatePurchaseStoreForm } from '@/api/store/purchaseForm'
import StoreSelectModal from '@/views/store/store/modules/StoreSelectModal'
export default {
  name: 'BasePurchaseStoreForm',
  components: {
    StoreSelectModal
  },
  data() {
    return {
      confirmLoading: false,
      modalTitle: null,
      form: this.$form.createForm(this),
      visible: false,
      // 下拉框map
      statusMap: {}
    }
  },
  props: {},
  created() {
    // 下拉框map
    this.statusMap = this.DictCache.getLabelByValueMapByType(this.DictCache.TYPE.PURCHASE_STORE_FORM_STATUS)
  },
  methods: {
    base(record) {
      this.visible = true
      // 如果是空标识添加
      if (this.BaseTool.Object.isBlank(record)) {
        this.modalTitle = '添加'
        return
      }
      this.modalTitle = '编辑'
      const { form: { setFieldsValue } } = this
      // 日期处理
      this.$nextTick(() => {
        setFieldsValue(Object.assign(pick(record, [
          'id',
          'status',
          'totalAmount',
          'totalNum',
          'name',
          'spareStoreName',
          'spareStoreId'
        ])))
      })
    },
    save() {
      const { form: { validateFieldsAndScroll } } = this
      this.confirmLoading = true
      validateFieldsAndScroll((errors, values) => {
        if (errors) {
          this.confirmLoading = false
          return
        }
        // 日期处理
        if (this.BaseTool.String.isBlank(values.id)) {
          addPurchaseStoreForm(values)
            .then(() => {
              this.handleCancel(values)
            }).catch(() => {
            this.confirmLoading = false
          })
        } else {
          updatePurchaseStoreForm(values)
            .then(() => {
              this.handleCancel(values)
            }).catch(() => {
            this.confirmLoading = false
          })
        }
      })
    },
    handleCancel(values) {
      this.visible = false
      this.confirmLoading = false
      this.form.resetFields()
      if (this.BaseTool.Object.isNotBlank(values)) {
        this.$emit('ok', values)
      } else {
        this.$emit('ok')
      }
    },
    spareStoreHandleSelect () {
      this.$refs.storeSelectModal.base({}, {})
    },
    spareStoreHandleSelectd (record, keys, rows) {
      const [key] = keys
      const [row] = rows
      const { form: { setFieldsValue } } = this
      // 日期处理
      this.$nextTick(() => {
        setFieldsValue(Object.assign({
          'spareStoreId': key,
          'spareStoreName': row.name
        }))
      })
    }
  }
}
</script>
